<?php
/**
 * ApiuploadcustomerData
 *
 * PHP version 5
 *
 * @category Class
 * @package  Boxx\Ai\Upload
 * @author   Swaagger Codegen team
 * @link     https://github.com/boxx-api/boxx-codegen
 */

/**
 * Upload and Delete Data API
 *
 * Boxx.ai's customer, product and interaction data ingestion sdk
 *
 * OpenAPI spec version: 1.4.0
 * Contact: aida@boxx.ai
 * Generated by: https://github.com/boxx-api/boxx-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the boxx code generator program.
 * https://github.com/boxx-api/boxx-codegen
 * Do not edit the class manually.
 */

namespace Boxx\Ai\Upload\Model;

use \ArrayAccess;

/**
 * ApiuploadcustomerData Class Doc Comment
 *
 * @category    Class
 * @description Upload data customer schema
 * @package     Boxx\Ai\Upload
 * @author      boxx Codegen team
 * @link        https://github.com/boxx-api/boxx-codegen
 */
class ApiuploadcustomerData implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $boxxModelName = 'apiuploadcustomer_data';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $boxxTypes = [
        'customerid' => 'string',
        'properties' => 'map[string,object]',
        'email' => 'string',
        'phone' => 'string',
        'location' => 'string[]',
        'device_tokens' => '\Boxx\Ai\Upload\Model\ApiuploadcustomerDeviceTokens[]',
        'mobile_tokens' => '\Boxx\Ai\Upload\Model\ApiuploadcustomerMobileTokens[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $boxxFormats = [
        'customerid' => null,
        'properties' => null,
        'email' => null,
        'phone' => null,
        'location' => null,
        'device_tokens' => null,
        'mobile_tokens' => null
    ];

    public static function boxxTypes()
    {
        return self::$boxxTypes;
    }

    public static function boxxFormats()
    {
        return self::$boxxFormats;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'customerid' => 'customerid',
        'properties' => 'properties',
        'email' => 'email',
        'phone' => 'phone',
        'location' => 'location',
        'device_tokens' => 'device_tokens',
        'mobile_tokens' => 'mobile_tokens'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'customerid' => 'setCustomerid',
        'properties' => 'setProperties',
        'email' => 'setEmail',
        'phone' => 'setPhone',
        'location' => 'setLocation',
        'device_tokens' => 'setDeviceTokens',
        'mobile_tokens' => 'setMobileTokens'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'customerid' => 'getCustomerid',
        'properties' => 'getProperties',
        'email' => 'getEmail',
        'phone' => 'getPhone',
        'location' => 'getLocation',
        'device_tokens' => 'getDeviceTokens',
        'mobile_tokens' => 'getMobileTokens'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['customerid'] = isset($data['customerid']) ? $data['customerid'] : null;
        $this->container['properties'] = isset($data['properties']) ? $data['properties'] : null;
        $this->container['email'] = isset($data['email']) ? $data['email'] : null;
        $this->container['phone'] = isset($data['phone']) ? $data['phone'] : null;
        $this->container['location'] = isset($data['location']) ? $data['location'] : null;
        $this->container['device_tokens'] = isset($data['device_tokens']) ? $data['device_tokens'] : null;
        $this->container['mobile_tokens'] = isset($data['mobile_tokens']) ? $data['mobile_tokens'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        if ($this->container['customerid'] === null) {
            $invalid_properties[] = "'customerid' can't be null";
        }
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if ($this->container['customerid'] === null) {
            return false;
        }
        return true;
    }


    /**
     * Gets customerid
     * @return string
     */
    public function getCustomerid()
    {
        return $this->container['customerid'];
    }

    /**
     * Sets customerid
     * @param string $customerid
     * @return $this
     */
    public function setCustomerid($customerid)
    {
        $this->container['customerid'] = $customerid;

        return $this;
    }

    /**
     * Gets properties
     * @return map[string,object]
     */
    public function getProperties()
    {
        return $this->container['properties'];
    }

    /**
     * Sets properties
     * @param map[string,object] $properties
     * @return $this
     */
    public function setProperties($properties)
    {
        $this->container['properties'] = $properties;

        return $this;
    }

    /**
     * Gets email
     * @return string
     */
    public function getEmail()
    {
        return $this->container['email'];
    }

    /**
     * Sets email
     * @param string $email
     * @return $this
     */
    public function setEmail($email)
    {
        $this->container['email'] = $email;

        return $this;
    }

    /**
     * Gets phone
     * @return string
     */
    public function getPhone()
    {
        return $this->container['phone'];
    }

    /**
     * Sets phone
     * @param string $phone
     * @return $this
     */
    public function setPhone($phone)
    {
        $this->container['phone'] = $phone;

        return $this;
    }

    /**
     * Gets location
     * @return string[]
     */
    public function getLocation()
    {
        return $this->container['location'];
    }

    /**
     * Sets location
     * @param string[] $location
     * @return $this
     */
    public function setLocation($location)
    {
        $this->container['location'] = $location;

        return $this;
    }

    /**
     * Gets device_tokens
     * @return \Boxx\Ai\Upload\Model\ApiuploadcustomerDeviceTokens[]
     */
    public function getDeviceTokens()
    {
        return $this->container['device_tokens'];
    }

    /**
     * Sets device_tokens
     * @param \Boxx\Ai\Upload\Model\ApiuploadcustomerDeviceTokens[] $device_tokens
     * @return $this
     */
    public function setDeviceTokens($device_tokens)
    {
        $this->container['device_tokens'] = $device_tokens;

        return $this;
    }

    /**
     * Gets mobile_tokens
     * @return \Boxx\Ai\Upload\Model\ApiuploadcustomerMobileTokens[]
     */
    public function getMobileTokens()
    {
        return $this->container['mobile_tokens'];
    }

    /**
     * Sets mobile_tokens
     * @param \Boxx\Ai\Upload\Model\ApiuploadcustomerMobileTokens[] $mobile_tokens
     * @return $this
     */
    public function setMobileTokens($mobile_tokens)
    {
        $this->container['mobile_tokens'] = $mobile_tokens;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\Boxx\Ai\Upload\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\Boxx\Ai\Upload\ObjectSerializer::sanitizeForSerialization($this));
    }
}


